#!/usr/bin/perl
#use strict;
#Start by including necessary libraries
use MARC::Record;
use Mysql;
#Some Variable definitions
$ret_file_name ="/usr/local/koha/intranet/scripts/misc/migration_tools/script_exports/100507mmr.mrc";
$host ="dbname.domain.com";
$user = "koha";
$pw = "pwd";
$database ="LIB";
$tablename = "mytable";
#Static MARC Fields

#Get records into an array
	# PERL MYSQL CONNECT()
	$connect = Mysql->connect($host, $database, $user, $pw);
	$connect->selectdb($database);
	# DEFINE A MySQL QUERY
	$myquery = "SELECT speakers,topic,rec_date,file_num FROM $tablename";
	#Query the db
	$execute = $connect->query($myquery);

## open a filehandle to write to.
	open(OUTPUT, "> $ret_file_name") or die $!;
	
#Loop through records array
while (@results = $execute->fetchrow()) {

	#Create a new MARC Record
	my $record = MARC::Record->new();
	
	#Add Static Fields
		#040a
		my $catalog_source =  MARC::Field->new(
		'040','','',
			a=>'Salk Institute Library',
			c=>'Salk Institute Library');
		#942c
		my $item_type = MARC::Field->new(
		'942','','', c =>'OPTI');
		#300a
		my $extent = MARC::Field->new(
		'300','','', a =>'DVD');
		#260a
		$place = 'The Salk Institute, 10010 North Torrey Pines Road, La Jolla, CA 92037';
		
			## figure out the contents of our new 005 field.
			my ($sec,$min,$hour,$mday,$mon,$year) = localtime();
			$year += 1900; $mon += 1; # catering to offsets.
			my $datetime = sprintf("%4d%02d%02d%02d%02d%02d.0",$year,$mon,$mday,$hour,$min,$sec); 
			## create a new 005 field using our new datetime.
		#005
		my $transaction_time = MARC::Field->new('005',$datetime);
		
	
	#loop through database returned fields
	my $controlnum = MARC::Field->new(
		'001',$results[3]);
	my $controlnumid =MARC::Field->new(
		'003',$results[3]);
	
	#append all fields up to this point	except for extent and item type, doing so out of sequence is not good
	$record->append_fields($controlnum,$controlnumid,$transaction_time, $catalog_source);
	
	my $author = MARC::Field->new(
  		'100','','',
  		a => $results[0]);
	$record->append_fields($author);
	
	
	
	my $title = MARC::Field->new(
  		'245','','',
 		a => "$results[1]" );
	$record->append_fields($title);
	
	

	my $place_time = MARC::Field->new(
  		'260','','',
 		a => $place,
		c => $results[2] );
	#Also append extent here
	$record->append_fields($place_time,$extent);
	
	
	if ($results[3])	{
	my $item_info = MARC::Field->new(
  		'952','','',
		c =>'Office',
		k =>'DVD '.$results[3],
 		p => 'DVD '.$results[3] );
	$record->append_fields($item_info);
	}
	
	#append the item_type last
	$record->append_fields($item_type);
	#print MARC record to open file
	 print OUTPUT $record->as_usmarc();
}

   #close open file
   	close(OUTPUT);
